//Robot Face

#include <RobotFace.h>
#include <Servo.h>

//3D printed facial components flag (0=no, 1=yes)
int printed_3d=0;

//Initial face servo positions
int lt_eye_init = 90;    // variable to store the servo position
int rt_eye_init = 90;
int lt_brow_init = 90;    // variable to store the servo position
int rt_brow_init = 90;
int lt_mc_init = 90;    // variable to store the servo position
int rt_mc_init = 90;
int lt_br_init = 60;    // variable to store the servo position
int rt_br_init =105;
int lt_mp_init = 60;
int rt_mp_init = 120;
int nt_init = 85;    // variable to store the servo position
int np_init = 95;

//Camera scale (based on 160x120 pixels = scale of 1)
int cam_scale=1;

//Camera Constants
int x_center = 80 * cam_scale;
int x_min = 20 * cam_scale;
int x_max = 140 * cam_scale;
int y_center = 55 * cam_scale;
int y_min = 20 * cam_scale;
int y_max = 90 * cam_scale;    
//Camera-view Move Constants (in terms of np/nt)
int x_move = 30;
int y_move = 15;

//Create Robot Instance
RobotFace Robot1(lt_eye_init, rt_eye_init, lt_brow_init, rt_brow_init, lt_mc_init, rt_mc_init, lt_br_init,
                  rt_br_init, lt_mp_init, rt_mp_init, nt_init, np_init,
                  x_center, x_min, x_max, y_center, y_min, y_max, x_move, y_move);

                 
                  
////////////////////////////////////////////////////////////////////////
//
// Main Program
//
///////////////////////////

 
void setup() 
{ 
  Robot1.Lt_Eye.attach(10);  // attaches the servo
  Robot1.Rt_Eye.attach(11);  // attaches the servo
  Robot1.Lt_Brow.attach(2);  // attaches the servo
  Robot1.Rt_Brow.attach(3);  // attaches the servo 
  Robot1.Lt_MC.attach(6);
  Robot1.Rt_MC.attach(7);
  Robot1.Lt_BrowRaise.attach(4);  // attaches the servo
  Robot1.Rt_BrowRaise.attach(5);  // attaches the servo
  Robot1.Lt_MouthPart.attach(8);  // attaches the servo
  Robot1.Rt_MouthPart.attach(9);  // attaches the servo
  Robot1.Neck_Tilt.attach(12);  // attaches the servo
  Robot1.Neck_Pan.attach(13);  // attaches the servo 
  
  Robot1.Initialize();                      //Initialize servo positions
  
  if (printed_3d==1)
  { Robot1.Set_Degree(1, 1, .8, 1, 1, 1, 1); }  //Sets reduced degreee for 3D printed mouth, if applicable
  
  Serial.begin(9600);
}
 
 
void loop() 
{ 
  //Sad Face
  Robot1.Sad_Face(1, 0);
  delay(3000);
  //De-sad
  Robot1.Sad_Face(-1, 0);
  delay(5000);
  
  //Happy Face
  Robot1.Happy_Face(1, 0);
  delay(3000);
  //De-happy
  Robot1.Happy_Face(-1, 0);
  delay(5000);
  
  //Angry Face
  Robot1.Angry_Face(1, 0);
  delay(3000);
  //De-angry
  Robot1.Angry_Face(-1, 0);
  delay(5000);
  
  //Fear Face
  Robot1.Fear_Face(1, 0);
  delay(3000);
  //De-fear
  Robot1.Fear_Face(-1, 0);
  delay(5000);
  
  //Surpise Face
  Robot1.Surprise_Face(1, 0);
  delay(3000);
  //De-surprise
  Robot1.Surprise_Face(-1, 0);
  delay(5000);
  
} 
